﻿#
# Author: Patrick Zambelli, patrick.zambelli@wuerth-phoenix.com
# (C) 2017 Würth Phoenix
#
#[String] $strmicrosec=$microsec.ToString()

$outStr = ""
$outPerfStr = ""
$outExitCode = 0

$actual = Get-NetAdapter | where {!$_.ConnectorPresent}|Get-NetAdapterStatistics

if ($actual.Count -le 0) {
    $actual = Get-NetConnectionProfile|get-netadapter|Get-NetAdapterStatistics
}

$actDatetime=date
$microsec=$actDatetime.ticks
$actual|Add-Member -NotePropertyName timestamp -NotePropertyValue $microsec

$file="$env:TEMP\NetAdapterStats.txt"

if ( Test-Path $file ) { 
    $prev = Import-Csv $file 
} else { 
    $prev = $actual
}


foreach ($previnterface in $prev)
{
   
   $actint=$actual|Where-Object { $_.InstanceID -eq $previnterface.InstanceID }

   if($actint)
   {
     $diffSendBytes= $actint.SentBytes - $previnterface.SentBytes
     $diffRecievedBytes= $actint.ReceivedBytes - $previnterface.ReceivedBytes

     $prevtick= ($previnterface.timestamp) -as [int64]
     $acttick= ($actint.timestamp) -as [int64]
     $timediff =  New-TimeSpan -Start $prevtick -End $acttick

     $totsec = $timediff.TotalSeconds 
     
     $diffSendBytesPerSec = $diffSendBytes / $totsec
     $diffReceivedBytesPerSec = $diffRecievedBytes / $totsec

     $outStr += "Int: $($previnterface.name) InByte/s: $diffReceivedBytesPerSec OutByt/s: $diffSendBytesPerSec "
     $outPerfStr += "`'$($previnterface.name)_in`'=$diffReceivedBytesPerSec;; `'$($previnterface.name)_out`'=$diffSendBytesPerSec;; "
     #Write-Host "interface: $($previnterface.name) Sendbyte/sec: $diffSendBytesPerSec  totsecdiff: $totsec" 
   }
}

$actual|select timestamp,InstanceID,name,ReceivedBytes,SentBytes|Export-Csv $file

Write-Host "$outStr | $outPerfStr"